#include	<windows.h>
#include	"common.h"
#include	"pc_core.h"
#include	"i286.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"gdc_sub.h"
#include	"bios.h"
#include	"crtc.h"

extern BYTE screenupdate;

void lio_init(void) {

	BYTE	i;

	mem[0xf9900] = 0x11;
	for (i=0; i<0x11; i++) {
		mem[0xf9904 + i*4] = 0xa0 + i;
		*(WORD *)(&mem[0xf9906 + i*4]) = 0x100 + i*2;
		*(WORD *)(&mem[0xf9a00 + i*2]) = 0xcf90;
	}
	mem[0xf9944] = 0xce;
}

void bios_lio(BYTE cmd) {

	switch(cmd) {
		case 0x00:			// a0: GINIT
			// GDCobt@
			if (gdc.s.cnt) {
				gdc_work(&gdc.s, &gdcs.grphdisp);
			}
			gdc_reset(&gdc.s);

			ZeroMemory(&gdc.s.para[GDC_SCROLL], 8);
			gdc.mode1 |= 0x10;
			gdc.s.para[GDC_CSRFORM] = 1;
			screenupdate |= 2;
			gdcs.access = gdcs.disp = 0;
			gdc.analog = 0;
			gdcs.grphdisp |= GDCSCRN_ENABLE;
			gdc_paletteinit();
			break;

		case 0x01:			// a1: GSCREEN
		case 0x02:			// a2: GVIEW
		case 0x03:			// a3: GCOLOR1
		case 0x04:			// a4: GCOLOR2
		case 0x05:			// a5: GCLS
		case 0x06:			// a6: GPSET
		case 0x07:			// a7: GLINE
		case 0x08:			// a8: GCIRCLE
		case 0x09:			// a9: GPAINT1
		case 0x0a:			// aa: GPAINT2
		case 0x0b:			// ab: GGET
		case 0x0c:			// ac: GPUT1
		case 0x0d:			// ad: GPUT2
		case 0x0e:			// ae: GROLL
		case 0x0f:			// af: GPOINT2
		case 0x10:			// ce: GCOPY
			break;
	}
}

