#include	<windows.h>
#include	"common.h"
#include	"iobridge.h"
#include	"memory.h"
#include	"dosio.h"
#include	"cgrom.h"
#include	"deffnt.h"

CGROM_TABLE		cgrom;

#ifdef __cplusplus
extern "C" {
#endif
CGWINDOW_TABLE	cgwindow;
BYTE			font[0x84000];
#ifdef __cplusplus
}
#endif

#define		FONTFILENAME	"font.bmp"
#define		FONTYSIZE		16
#define		BMPWIDTH		2048L
#define		BMPHEIGHT		2048L
#define		BMPLINESIZE		(BMPWIDTH / 8)			// ؂^^;
#define		BMPDATASIZE		(BMPLINESIZE * BMPHEIGHT)


int loadfont(void) {

	FILEH				fh;
	int					i, j, k;
	BYTE				bit;
	BYTE				*p, *q;
	BITMAPFILEHEADER	bmf;
	BITMAPINFOHEADER	bmi;
	HANDLE				hbmpdata;
	BYTE				*bmpdata;

	ZeroMemory(font, sizeof(font));

	p = font + 0x80000;
	q = deffnt8x8;
	for (i=0; i<256; i++) {
		for (j=0; j<8; j++) {
			*p++ = *q;
			*p++ = *q++;
		}
	}

	p = font + 0x81000;
	q = font + 0x82800;
	for (i=0; i<256; i++) {
		for (j=0; j<4; j++) {
			bit = 0;
			if (i & (0x01 << j)) {
				bit |= 0xf0;
			}
			if (i & (0x10 << j)) {
				bit |= 0xff;
			}
			for (k=0; k<4; k++) {
				*p++ = bit;
			}
			for (k=0; k<2; k++) {
				*q++ = bit;
			}
		}
	}

	CopyMemory(font + 0x82000, deffnt8x8, 0x800);


	// t@C݂邩H
	if (file_attr_c(FONTFILENAME) == -1) {
		return(FALSE);						// t@C݂Ȃ
	}

	// A[P[g
	if ((hbmpdata = GlobalAlloc(GPTR, BMPDATASIZE)) == NULL) {
		return(FALSE);						// A[P[gɎs
	}

	// bNyу|C^擾
	if ((bmpdata = (BYTE *)GlobalLock(hbmpdata)) == NULL) {
		GlobalFree(hbmpdata);				// A[P[gɎs
		return(FALSE);
	}

	// t@CI[v
	if ((fh = file_open_c(FONTFILENAME)) == (FILEH)-1) {
		GlobalUnlock(hbmpdata);				// I[vɎs
		GlobalFree(hbmpdata);
		return(FALSE);
	}

	for (;;) {								// gotogȂ ܂Ȃ
		// BITMAPFILEHEADER ̓ǂݍ
		if (file_read(fh, &bmf, sizeof(BITMAPFILEHEADER))
								!= sizeof(BITMAPFILEHEADER)) {
			break;							// ǂݍݎs
		}

		// ^Cv BMH
		if (bmf.bfType != 0x4d42) {
			break;							// "BM" ł͂Ȃ
		}

		// BITMAPINFOHEADER ̓ǂݍ
		if (file_read(fh, &bmi, sizeof(BITMAPINFOHEADER))
								!= sizeof(BITMAPINFOHEADER)) {
			break;							// ǂݍݎs
		}

		// \̃TCY͐H
		if (bmi.biSize != sizeof(BITMAPINFOHEADER)) {
			break;							// s
		}
		// v[͂PH
		if (bmi.biPlanes != 1) {
			break;							// s
		}
		// PFł邩H
		if (bmi.biBitCount != 1) {
			break;							// s
		}
		// TCY͐H
		if (bmi.biWidth != BMPWIDTH) {
			break;							// s
		}
		// cTCY͐H
		if (bmi.biHeight != BMPHEIGHT) {
			break;							// s
		}
		// C[WTCY͂Ă邩H
		if (bmi.biSizeImage != BMPDATASIZE) {
			break;							// s
		}
		// kH
		if (bmi.biCompression != 0) {
			break;							// s
		}

		// BITMAPf[^
		if (file_seek(fh, bmf.bfOffBits, FSEEK_SET) != bmf.bfOffBits) {
			break;							// V[NɎs
		}

		// BITMAPf[^̓ǂ݂
		if (file_lread(fh, bmpdata, BMPDATASIZE) != BMPDATASIZE) {
			break;							// ɓǂ݂Ȃ
		}

		// ANK̃Rs[
		q = font + 0x80000;
		for (i=0; i<256; i++) {
			p = bmpdata + BMPDATASIZE + i;
			for (j=0; j<16; j++) {
				p -= BMPLINESIZE;
				*q++ = ~(*p);
			}
		}

		// ̃Rs[
		for (i=0x01; i<0x60; i++) {
			q = font + 0x1000 + (i << 4);
			p = bmpdata + BMPDATASIZE + (i << 1)
										- (FONTYSIZE * BMPLINESIZE);
			for (j=1; j<0x80; j++) {
				for (k=0; k<16; k++) {
					p -= BMPLINESIZE;
					*(q + 0x800) = ~(*(p+1));
					*q++ = ~(*p);
				}
				q += 0x1000 - 16;
			}
		}
		break;
	}
	file_close(fh);							// n
	GlobalUnlock(hbmpdata);
	GlobalFree(hbmpdata);
	return(TRUE);
}

// ---------------------------------------------------------------------------

static void cgwindowset(void) {

	cgwindow.low = 0x7fff0;
	cgwindow.writable = 0;
	if (!(cgrom.code.w & 0xff00)) {
		cgwindow.high = 0x80000 + (cgrom.code.w << 4);
	}
	else {
		BYTE code = cgrom.code.w & 0x007f;
		cgwindow.high = (cgrom.code.w & 0x7f7f) << 4;
		if ((code >= 0x56) && (code < 0x58)) {
			cgwindow.writable = 1;
			cgwindow.high += cgrom.lr;
		}
		else if (((code >= 0x0c) && (code < 0x10)) ||
			((code >= 0x58) && (code < 0x60))) {
			cgwindow.high += cgrom.lr;
		}
		else if ((code < 0x08) || (code >= 0x10)) {
			cgwindow.low = cgwindow.high;
			cgwindow.high += 0x800;
		}
	}
}

// ---------------------------------------------------------------------------

void cgrom_init(void) {

	ZeroMemory(&cgrom, sizeof(cgrom));
	cgwindow.low = 0x7fff0;
	cgwindow.high = 0x7fff0;
	cgwindow.writable = 0;
}


I286_OUT cgrom_w(WORD port, BYTE value) {

	switch(port & 0x0f) {
		case 1:						// write charactor code low
			cgrom.code.b[1] = value;
			cgwindowset();
			break;
		case 3:						// write charactor code high
			cgrom.code.b[0] = value;
			cgwindowset();
			break;
		case 5:						// write charactor line
			cgrom.line = value & 0x0f;
			cgrom.lr = ((~value) & 0x20) << 6;
			break;
		case 9:						// CG write pattern
			if ((cgrom.code.w & 0x007e) == 0x0056) {
				font[((cgrom.code.w & 0x7f7f) << 4) + cgrom.lr
												+ cgrom.line] = value;
			}
			break;
	}
}

I286_INB cgrom_r(WORD port) {

	if ((port & 0x0f) == 0x09) {
		if (cgrom.code.w & 0xff00) {						// kanji
			return(font[((cgrom.code.w & 0x7f7f) << 4) + cgrom.lr
												+ cgrom.line]);
		}
		else {												// ascii?
			return(font[0x80000 + (cgrom.code.w << 4) + cgrom.line]);
		}
	}
	return(0xff);
}
