#include	<windows.h>
#include	<windowsx.h>

#include	"common.h"
#include	"np2.h"
#include	"ddraws.h"
#include	"dosio.h"
#include	"menu.h"
#include	"ini.h"
#include	"iobridge.h"
#include	"gdc.h"

typedef struct {
	BITMAPFILEHEADER	bmf;
	BITMAPINFOHEADER	bmi;
	PALETTE_TABLE		pal[256];
//	BYTE				data[0];
} BMP_CTRL;

#define	PALADDED		32

static	char	bmpext[] = "bmp";
static	char	bmptitle[] = "Bitmap̕ۑ";
static	char	*bmpextstr[] = {
						"2Frbg}bv\0*.bmp\0",
						"16Frbg}bv\0*.bmp\0",
						"256Frbg}bv\0*.bmp\0",
						"tJ[rbg}bv\0*.bmp\0"};


BYTE bmps_appal(int *pals, PALETTE_TABLE *pal, DWORD col) {

	int		ret;

	col &= 0x00ffffff;
	for (ret=0; ret<(*pals); ret++) {
		if (pal[ret].d == col) {
			return((BYTE)ret);
		}
	}
	(*pals)++;
	if (*pals > 256) {
		return(0);
	}
	pal[ret].d = col;
	return((BYTE)ret);
}

void bmpsavefile(LPSTR filename, BMP_CTRL *bmc) {

	FILEH	dst;
	DWORD	linesize;
	long	x;
	long	y;
	BYTE	*p;
	BYTE	bit;
	BYTE	work[SCREEN_WIDTH];

	if (bmc->bmi.biClrImportant <= 2) {
		bmc->bmi.biBitCount = 1;
		bmc->bmi.biClrUsed = 2L;
	}
	else if (bmc->bmi.biClrImportant <= 16) {
		bmc->bmi.biBitCount = 4;
		bmc->bmi.biClrUsed = 16L;
	}
	else if (bmc->bmi.biClrImportant <= 256) {
		bmc->bmi.biBitCount = 8;
		bmc->bmi.biClrUsed = 256L;
	}
	else {
		bmc->bmi.biBitCount = 24;
		bmc->bmi.biClrUsed = 0;
		bmc->bmi.biClrImportant = 0;
	}
	linesize = (((bmc->bmi.biWidth * bmc->bmi.biBitCount + 31) >> 5) << 2);
	bmc->bmf.bfType = 0x4d42;
	bmc->bmi.biSize = sizeof(BITMAPINFOHEADER);
	bmc->bmi.biPlanes = 1;
	bmc->bmi.biSizeImage = bmc->bmi.biHeight * linesize;
	bmc->bmf.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)
												+ (bmc->bmi.biClrUsed * 4);
	bmc->bmf.bfSize = bmc->bmf.bfOffBits + bmc->bmi.biSizeImage;


	if ((dst = file_create(filename)) != (FILEH)-1) {
		file_lwrite(dst, bmc, bmc->bmf.bfOffBits);
		y = bmc->bmi.biHeight;
		while(y--) {
			p = (BYTE *)bmc + sizeof(BMP_CTRL) + (y * bmc->bmi.biWidth);
			if (bmc->bmi.biBitCount == 1) {
				bit = 0x80;
				ZeroMemory(work, sizeof(work));
				for (x=0; x<bmc->bmi.biWidth; x++) {
					if (*p++) {
						work[x/8] |= bit;
					}
					__asm {
						ror		bit, 1
					}
				}
				file_lwrite(dst, work, linesize);
			}
			else if (bmc->bmi.biBitCount == 4) {
				bit = 0;
				ZeroMemory(work, sizeof(work));
				for (x=0; x<bmc->bmi.biWidth; x++) {
					if (bit) {
						work[x/2] |= *p++;
					}
					else {
						work[x/2] = (BYTE)((*p++) << 4);
					}
					bit ^= 1;
				}
				file_lwrite(dst, work, linesize);
			}
			else if (bmc->bmi.biBitCount == 8) {
				file_lwrite(dst, p, linesize);
			}
			else if (bmc->bmi.biBitCount == 24) {
				p = (BYTE *)bmc + sizeof(BMP_CTRL)
											+ (3L * y * bmc->bmi.biWidth);
				file_lwrite(dst, p, linesize);
			}
		}
		file_close(dst);
	}
}


void screenmix(void *dest, void *src) {

	DWORD	*p = (DWORD *)src;
	DWORD	*q = (DWORD *)dest;
	int		i;

	for (i=0; i<(SCREEN_WIDTH * SCREEN_HEIGHT / 4); i++) {
		(*q++) |= (*p++);
	}
}



void bmpsave(void) {

	HANDLE		hbmc;
	BMP_CTRL	*bmc;
	HANDLE		hscrn;
	BYTE		*scrn;
	BYTE		*p, *q;
	BYTE		remap[256];
	BYTE		remapflg[256];
	BYTE		c;
	int			pals = 0;
	long		x, y;
	char		*f;
	LPSTR		r;

	if ((hbmc = GlobalAlloc(GPTR, (DWORD)sizeof(BMP_CTRL) + 1 +
					((DWORD)SCREEN_WIDTH * SCREEN_HEIGHT * 3L))) == NULL) {
		return;
	}
	if ((bmc = (BMP_CTRL *)GlobalLock(hbmc)) == NULL) {
		GlobalFree(hbmc);
		return;
	}
	if ((hscrn = GlobalAlloc(GPTR, (DWORD)SCREEN_WIDTH*SCREEN_HEIGHT))
																== NULL) {
		GlobalUnlock(hbmc);
		GlobalFree(hbmc);
		return;
	}
	if ((scrn = (BYTE *)GlobalLock(hscrn)) == NULL) {
		GlobalFree(hscrn);
		GlobalUnlock(hbmc);
		GlobalFree(hbmc);
		return;
	}

	ZeroMemory(scrn, SCREEN_WIDTH*SCREEN_HEIGHT);
	ZeroMemory(bmc, sizeof(BMP_CTRL));
	ZeroMemory(remap, 256);
	ZeroMemory(remapflg, 256);
	bmc->bmi.biWidth = SCREEN_WIDTH;
	bmc->bmi.biHeight = SCREEN_HEIGHT;

	if (gdcs.textdisp & 0x80) {
		screenmix(scrn, np2_tram);
	}
	if (gdcs.grphdisp & 0x80) {
		screenmix(scrn, np2_vram[gdcs.disp]);
	}

	p = scrn;
	q = (BYTE *)bmc + sizeof(BMP_CTRL);
	for (y=0; y<SCREEN_HEIGHT; y++) {
		for (x=0; x<SCREEN_WIDTH; x++) {
			c = *p++;
			if (!remapflg[c]) {
				remapflg[c] = 1;
				remap[c] = bmps_appal(&pals, bmc->pal, np2_palette[c].d);
			}
			*q++ = remap[c];
		}
		if (pals > 256) {
			break;
		}
	}
	bmc->bmi.biClrImportant = (DWORD)pals;
	f = bmpextstr[0];
	if (pals > 256) {
		f = bmpextstr[3];
		p = scrn;
		q = (BYTE *)bmc + sizeof(BMP_CTRL);
		for (y=0; y<SCREEN_HEIGHT; y++) {
			for (x=0; x<SCREEN_WIDTH; x++) {
				*(DWORD *)q = np2_palette[*p++].d;
				q += 3;
			}
		}
	}
	else if (pals > 16) {
		f = bmpextstr[2];
	}
	else if (pals > 2) {
		f = bmpextstr[1];
	}

	GlobalUnlock(hscrn);
	GlobalFree(hscrn);

	if ((r = savefileselect(f, "NP2_%04d.BMP", bmpext, bmptitle)) != NULL) {
		bmpsavefile(r, bmc);
	}

	GlobalUnlock(hbmc);
	GlobalFree(hbmc);
}

