#include	<windows.h>
#include	<windowsx.h>
#include	"resource.h"
#include	"common.h"
#include	"np2.h"
#include	"dialog.h"
#include	"ini.h"
#include	"dosio.h"
#include	"pc_core.h"
#include	"iobridge.h"
#include	"midi.h"
#include	"menu.h"

	int		sound_renewals = 0;

#define	GETCHECK(a,b) ((Button_GetCheck(GetDlgItem(a, b)))?1:0)
#define	AVE(a, b)	((a+b)/2)

static char *basecstr[2] = {"2.4576MHz", "1.9968MHz"};
static char *mulstr[10] = {"1","2","4","5","6","8","10","12","16","20"};
static char notused[] = "gp";
static char other[] = "̑";

// --------------------------------------------------------------------------

static void SetClock(HWND hWnd) {

	DWORD	dval;
	char	work[32];

	Edit_GetText(GetDlgItem(hWnd, IDC_BASECLOCK), work, 32);
	if (work[0] == '1') {
		dval = PCBASECLOCK20 / 100;
	}
	else {
		dval = PCBASECLOCK25 / 100;
	}
	Edit_GetText(GetDlgItem(hWnd, IDC_MULTIPLE), work, 32);
	dval *= (DWORD)ex_a2i(work, 1, 32);
	wsprintf(work, "%2u.%04u", dval / 10000, dval % 10000);
	SetDlgItemText(hWnd, IDC_CLOCKMSG, work);
}


LRESULT CALLBACK CfgDialogProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) {

#define	WORKSIZE		128

		char	work[WORKSIZE];
		int		i, midimodmax;
		BYTE	bval;
		WORD	wval;
		DWORD	dval;
		char	*p;
static	int		mimpifilechange = 0;
static	char	mimpifile[MAX_PATH];

	switch (msg) {
		case WM_INITDIALOG:
			for (i=0; i<2; i++) {
				SendMessage(GetDlgItem(hWnd, IDC_BASECLOCK),
						CB_INSERTSTRING, (WPARAM)i, (LPARAM)basecstr[i]);
			}
			if (np2cfg.baseclock >= AVE(PCBASECLOCK25, PCBASECLOCK20)) {
				SendMessage(GetDlgItem(hWnd, IDC_BASECLOCK),
								CB_SETCURSEL, (WPARAM)0, (LPARAM)0);
			}
			else {
				SendMessage(GetDlgItem(hWnd, IDC_BASECLOCK),
								CB_SETCURSEL, (WPARAM)1, (LPARAM)0);
			}

			for (i=0; i<10; i++) {
				SendMessage(GetDlgItem(hWnd, IDC_MULTIPLE),
						CB_INSERTSTRING, (WPARAM)i, (LPARAM)mulstr[i]);
			}
			wsprintf(work, "%u", np2cfg.multiple);
			Edit_SetText(GetDlgItem(hWnd, IDC_MULTIPLE), work);

			if (np2cfg.samplingrate < AVE(11025, 22050)) {
				Button_SetCheck(GetDlgItem(hWnd, IDC_RATE11), TRUE);
			}
			else if (np2cfg.samplingrate < AVE(22050, 44100)) {
				Button_SetCheck(GetDlgItem(hWnd, IDC_RATE22), TRUE);
			}
			else {
				Button_SetCheck(GetDlgItem(hWnd, IDC_RATE44), TRUE);
			}

			wsprintf(work, "%u", np2cfg.delayms);
			Edit_SetText(GetDlgItem(hWnd, IDC_SOUNDBUF), work);

			SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE),
					CB_INSERTSTRING, (WPARAM)0, (LPARAM)notused);
			midimodmax = MIDI_modules();
			for (i=0; i<midimodmax; i++) {
				SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE),
					CB_INSERTSTRING, (WPARAM)i+1, 
					(LPARAM)MIDI_num2module(i+1));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE), CB_INSERTSTRING,
									(WPARAM)midimodmax+1, (LPARAM)other);
			Button_SetCheck(GetDlgItem(hWnd, IDC_MIDIRESET), np2cfg.MIDIRESET);
			if (np2cfg.MIDIMODULE <= midimodmax) {
				SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE), CB_SETCURSEL,
									(WPARAM)np2cfg.MIDIMODULE, (LPARAM)0);
			}
			else {
				SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE), CB_SETCURSEL,
									(WPARAM)(midimodmax+1), (LPARAM)0);
			}
			mimpifilechange = 0;
			strcpy(mimpifile, mimpideffile);
			SetDlgItemText(hWnd, IDC_MIMPIFILENAME, getFileName(mimpifile));
			SetClock(hWnd);
			return(FALSE);

		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					Edit_GetText(GetDlgItem(hWnd, IDC_BASECLOCK),
													work, WORKSIZE);
					if (work[0] == '1') {
						dval = PCBASECLOCK20;
					}
					else {
						dval = PCBASECLOCK25;
					}
					if (dval != np2cfg.baseclock) {
						INIT_RENEWAL np2cfg.baseclock = dval;
					}

					Edit_GetText(GetDlgItem(hWnd, IDC_MULTIPLE),
													work, WORKSIZE);
					if ((dval = (DWORD)ex_a2i(work, 1, 32))
											!= np2cfg.multiple) {
						INIT_RENEWAL np2cfg.multiple = dval;
					}

					if (GETCHECK(hWnd, IDC_RATE11)) {
						wval = 11025;
					}
					else if (GETCHECK(hWnd, IDC_RATE22)) {
						wval = 22050;
					}
					else {
						wval = 44100;
					}
					if (wval != np2cfg.samplingrate) {
						sound_renewals = 1;
						INIT_RENEWAL np2cfg.samplingrate = wval;
					}

					Edit_GetText(GetDlgItem(hWnd, IDC_SOUNDBUF),
													work, WORKSIZE);
					if ((wval = (WORD)ex_a2i(work, 100, 1000))
											!= np2cfg.delayms) {
						sound_renewals = 1;
						INIT_RENEWAL np2cfg.delayms = wval;
					}

					Edit_GetText(GetDlgItem(hWnd, IDC_MIDIMODULE),
													work, WORKSIZE);
					if (!strcmp(work, notused)) {
						bval = MIDINUM_NOTUSED;
					}
					else {
						bval = MIDI_module2num(work);
					}
					if (bval != np2cfg.MIDIMODULE) {
						INIT_RENEWAL np2cfg.MIDIMODULE = bval;
					}

					bval = GETCHECK(hWnd, IDC_MIDIRESET);
					if (bval != np2cfg.MIDIRESET) {
						INIT_RENEWAL np2cfg.MIDIRESET = bval;
					}

					if (mimpifilechange) {
						INIT_RENEWAL;
						strcpy(mimpideffile, mimpifile);
						if (MIDI_SetMimpiMap(mimpifile)) {
							MIDI_EnableMimpiDef(FALSE);
							xmenu_setmimpidef(0x00);
						}
						else {
							xmenu_setmimpidef(0x80);
						}
					}

					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;

				case IDC_BASECLOCK:
				case IDC_MULTIPLE:
					SetClock(hWnd);
					return(FALSE);

				case IDC_MIMPISELECT:
					p = filenameselect(mimpifile, "MIMPI DEF̧قJ",
									"MIMPI DEF file(*.def)\0*.def\0", "def");
					mimpifilechange = 1;
					if (p) {
						strcpy(mimpifile, p);
						SetDlgItemText(hWnd, IDC_MIMPIFILENAME,
															getFileName(p));
					}
					else {
						strcpy(mimpifile, "");
						SetDlgItemText(hWnd, IDC_MIMPIFILENAME, "");
					}
					return(FALSE);

				default:
					return(FALSE);
			}
			break;

		case WM_CLOSE:
			PostMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
			break;

		default:
			return(FALSE);
	}
	return(TRUE);
}

// --------------------------------------------------------------------------

LRESULT CALLBACK AboutDialogProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) {

	switch (msg) {
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				default:
					return(FALSE);
			}
		case WM_CLOSE:
			PostMessage(hWnd, WM_COMMAND, IDOK, 0);
			break;
		default:
			return(FALSE);
	}
	return(TRUE);
}
