//
// FDC PD72065 + PD765A
//


// ܂SRoĂȂc

// #define	KEROPI
#define		NEKO

#include	<windows.h>
#include	"fdc.h"
#include	"fddfile.h"

#ifdef KEROPI						// PD72065
#include	"fdc.h"
#include	"fdd.h"
#include	"ioc.h"
#include	"irqh.h"
#include	"m68000.h"
#include	"../win32/fileio.h"
#include	"../win32/status.h"
#include	"../win32/winx68k.h"
#include	"../win32/windraw.h"
#include	"../win32/resource.h"
#endif

#ifdef NEKO							// PD765A
#include	"common.h"
#include	"dosio.h"
#include	"pc_core.h"
#include	"i286.h"
#include	"iobridge.h"
//#include	"dma.h"
#endif


enum {
	FDCEVENT_NEUTRAL,
	FDCEVENT_CMDRECV,
	FDCEVENT_DATSEND,
	FDCEVENT_BUFRECV,
	FDCEVENT_BUFSEND,
	FDCEVENT_NEXTDATA,
};

	FDC_TABLE		fdc;

static BYTE FDCCMD_TABLE[32] = {
						0, 0, 8, 2, 1, 8, 8, 1, 0, 8, 1, 0, 8, 5, 0, 2,
						0, 8, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 8, 0, 0};

// ------------------------------------------------------------- @ˑ

#ifdef KEROPI									// WinX68k
#define FDC_FORCEREADY (1)
#define	FDC_MAXDRIVE	2

static void fdc_interrupt(void) {

	IOC_IntStat |= 0x80;
	if (IOC_IntStat & 4) {
		IRQH_Int(1, &FDC_Int);
	}
}

static void fdc_interruptreset(void) {

	IOC_IntStat &= 0x7f;
}

static BOOL fdc_isfdcinterrupt(void) {

	if (IOC_IntStat & 0x80) {
		return(TRUE);
	}
	return(FALSE);
}
#endif

#ifdef NEKO										// Neko Project II
#define FDC_FORCEREADY (1)
#define	FDC_MAXDRIVE	2

static void fdc_interrupt(void) {

}

static void fdc_interruptreset(void) {

}

static BOOL fdc_isfdcinterrupt(void) {

	return(TRUE);
}
#endif


// ----------------------------------------------------------------------

static void send_error7(void) {

	fdc.event = FDCEVENT_DATSEND;
	fdc.datp = 0;
	fdc.datcnt = 7;
	fdc.data[0] = fdc.status[fdc.us];
	fdc.data[1] = 0;
	fdc.data[2] = 0;
	*(DWORD *)(&fdc.data[3]) = *(DWORD *)(&fdc.C);
	fdc_interrupt();
}

static BOOL FDC_SeekCheck(BYTE protectcheck) {

	if (!fddfile[fdc.us].fname[0]) {
		fdc.status[fdc.us] = 0x48 | (fdc.hd << 2) | fdc.us;
		send_error7();
		return(FALSE);
	}
	else if ((protectcheck) && (fddfile[fdc.us].protect)) {
		fdc.status[fdc.us] = 0x40 | (fdc.hd << 2) | fdc.us;
		send_error7();
		return(FALSE);
	}
	return(TRUE);
}

// ----------------------------------------------------------------------

static void get_mtmfsk(void) {

	fdc.mt = (fdc.cmd >> 7) & 1;
	fdc.mf = (fdc.cmd >> 6) & 1;
	fdc.sk = (fdc.cmd >> 5) & 1;
}

static void get_hdus(void) {

	fdc.hd = (fdc.cmds[0] >> 2) & 1;
	fdc.us = fdc.cmds[0] & 3;
}

static void get_chrn(void) {

	*(DWORD *)(&fdc.C) = *(DWORD *)(&fdc.cmds[1]);
}

static void get_eotgsldtl(void) {

	fdc.eot = fdc.cmds[5];
	fdc.gpl = fdc.cmds[6];
	fdc.dtl = fdc.cmds[7];
}

// --------------------------------------------------------------------------

static void FDC_Invalid(void) {							// cmd: xx

	fdc.event = FDCEVENT_DATSEND;
	fdc.data[0] = 0x80;
	fdc.datp = 0;
	fdc.datcnt = 1;
}


static void FDC_ReadDiagnostic(void) {					// cmd: 02

	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			get_chrn();
			get_eotgsldtl();
			fdc.status[fdc.us] = (fdc.hd << 2) | fdc.us;

			if (FDC_SeekCheck(FALSE)) {
				fdc.event = FDCEVENT_BUFSEND;
//				fdc.bufcnt = makedianosedata();
				fdc.bufp = 0;
			}
			break;

		default:
			fdc.event = FDCEVENT_NEUTRAL;
			break;
	}
}

static void FDC_Specify(void) {							// cmd: 03

	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			fdc.srt = fdc.cmds[0] >> 4;
			fdc.hut = fdc.cmds[0] & 0x0f;
			fdc.hlt = fdc.cmds[1] >> 1;
			fdc.nd = fdc.cmds[1] & 1;
			fdc.status[fdc.us] = (fdc.hd << 2) | fdc.us;
			break;
	}
	fdc.event = FDCEVENT_NEUTRAL;
}

static void FDC_SenseDeviceStatus(void) {				// cmd: 04

	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			fdc.status[fdc.us] = (fdc.hd << 2) | fdc.us;
			fdc.data[0] = fdc.status[fdc.us];
			if (fddfile[fdc.us].fname[0]) {
				fdc.data[0] |= 0x20;
			}
			if (fddfile[fdc.us].protect) {
				fdc.data[0] |= 0x40;
			}
			fdc.data[0] |= 0x10;

			fdc.event = FDCEVENT_BUFSEND;
			fdc.datcnt = 1;
			fdc.datp = 0;
			break;

		default:
			fdc.event = FDCEVENT_NEUTRAL;
			break;
	}
}

static void FDC_WriteData(void) {						// cmd: 05
														// cmd: 09
	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			get_chrn();
			get_eotgsldtl();
			fdc.status[fdc.us] = (fdc.hd << 2) | fdc.us;
			if (FDC_SeekCheck(TRUE)) {
				fdc.event = FDCEVENT_BUFRECV;
				fdc.bufcnt = 128 << fdc.N;
				fdc.bufp = 0;
			}
			break;

		case FDCEVENT_NEXTDATA:
			fdc.event = FDCEVENT_NEUTRAL;
			break;

		default:
			fdc.event = FDCEVENT_NEUTRAL;
			break;
	}
}

static void FDC_ReadData(void) {						// cmd: 06
														// cmd: 0c
	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			get_chrn();
			get_eotgsldtl();
			fdc.status[fdc.us] = (fdc.hd << 2) | fdc.us;
			if (FDC_SeekCheck(FALSE)) {
				fdc.event = FDCEVENT_BUFSEND;
//				fdc.bufcnt = readsectordata();
				fdc.bufp = 0;
			}
			break;

		case FDCEVENT_NEXTDATA:
			fdc.event = FDCEVENT_NEUTRAL;
			break;

		default:
			fdc.event = FDCEVENT_NEUTRAL;
			break;
	}
}

static void FDC_Recalibrate(void) {						// cmd: 07

	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			fdc.status[fdc.us] = (fdc.hd << 2) | fdc.us;
			if ((fddfile[fdc.us].fname[0]) || (FDC_FORCEREADY)) {
				if (fdc.us < FDC_MAXDRIVE) {
					fdc.status[fdc.us] |= 0x20;
				}
				else {
					fdc.status[fdc.us] |= 0x50;
				}
			}
			else {		// Not Ready
				fdc.status[fdc.us] |= 0x48;
			}
			fdc_interrupt();
			break;
	}
	fdc.event = FDCEVENT_NEUTRAL;
}

static void FDC_SenceintStatus(void) {					// cmd: 08

	int		i;

	fdc.event = FDCEVENT_DATSEND;
	fdc.datp = 0;
	fdc.datcnt = 0;

	if (fdc_isfdcinterrupt()) {
		fdc_interruptreset();
		for (i=0; i<4; i++) {
			if (fdc.status[i]) {
				fdc.data[0] = fdc.status[i];
				fdc.data[1] = fdc.C;
				fdc.datcnt = 2;
				fdc.status[i] = 0;
				break;
			}
		}
		for (; i<4; i++) {
			if (fdc.status[i]) {
				fdc_interrupt();
				return;
			}
		}
		if (!fdc.datcnt) {
			fdc.event = FDCEVENT_NEUTRAL;
		}
	}
	else {
		fdc.data[0] = 0x80;
		fdc.datcnt = 1;
	}
}

static void FDC_ReadID(void) {							// cmd: 0a

	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			break;
	}
}

static void FDC_WriteID(void) {							// cmd: 0d

	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			fdc.N = fdc.cmds[1];
			fdc.sc = fdc.cmds[2];
			fdc.gpl = fdc.cmds[3];
			fdc.d = fdc.cmds[4];
			break;
	}
}

static void FDC_Seek(void) {							// cmd: 0f

	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			fdc.ncn = fdc.cmds[1];
			break;
	}
}

static void FDC_ScanEqual(void) {						// cmd: 11, 19, 1d

	switch(fdc.event) {
		case FDCEVENT_CMDRECV:
			get_hdus();
			get_chrn();
			fdc.eot = fdc.cmds[5];
			fdc.gpl = fdc.cmds[6];
			fdc.stp = fdc.cmds[7];
			break;
	}
}

// --------------------------------------------------------------------------

void (*FDC_Ope[0x20])(void) = {
				FDC_Invalid,
				FDC_Invalid,
				FDC_ReadDiagnostic,
				FDC_Specify,
				FDC_SenseDeviceStatus,
				FDC_WriteData,
				FDC_ReadData,
				FDC_Recalibrate,
				FDC_SenceintStatus,
				FDC_WriteData,
				FDC_ReadID,
				FDC_Invalid,
				FDC_ReadData,
				FDC_WriteID,
				FDC_Invalid,
				FDC_Seek,
				FDC_Invalid,					// 10
				FDC_ScanEqual,
				FDC_Invalid,
				FDC_Invalid,
				FDC_Invalid,
				FDC_Invalid,
				FDC_Invalid,
				FDC_Invalid,
				FDC_Invalid,
				FDC_ScanEqual,
				FDC_Invalid,
				FDC_Invalid,
				FDC_Invalid,
				FDC_ScanEqual,
				FDC_Invalid,
				FDC_Invalid};


// --------------------------------------------------------------------------

void FDC_Init(void) {

	ZeroMemory(&fdc, sizeof(fdc));
}

void FDC_DataRegWrite(BYTE data) {

	switch(fdc.event) {
		case FDCEVENT_BUFRECV:
			fdc.buf[fdc.bufp++] = data;
			if (!(--fdc.bufcnt)) {
				FDC_Ope[fdc.cmd & 0x1f]();
			}
			break;

		case FDCEVENT_CMDRECV:
			fdc.cmds[fdc.cmdp++] = data;
			if (!(--fdc.cmdcnt)) {
				get_mtmfsk();
				FDC_Ope[fdc.cmd & 0x1f]();
			}
			break;

		default:
			fdc.cmd = data;
			fdc.event = FDCEVENT_CMDRECV;
			fdc.cmdp = 0;
			fdc.cmdcnt = FDCCMD_TABLE[data & 0x1f];
			if (!fdc.cmdcnt) {
				get_mtmfsk();
				FDC_Ope[fdc.cmd & 0x1f]();
			}
			break;
	}
}

