
#define	GET_PREFIX_DS											\
				__asm {	mov		edi, DS_FIX					}

#define	GET_PREFIX_SS											\
				__asm {	mov		edi, SS_FIX					}


									// dest: I286_REG[eax] src: dl
#define	PREPART_EA_REG8(regclk)									\
				GET_PCBYTE										\
				__asm {	mov		ebx, eax					}	\
				__asm {	shr		ebx, 3						}	\
				__asm {	bt		bx, 2						}	\
				__asm {	rcl		ebx, 1						}	\
				__asm {	and		ebx, 7						}	\
				__asm {	cmp		al, 0c0h					}	\
				__asm {	jc		memory_eareg8				}	\
				__asm {	bt		ax, 2						}	\
				__asm { rcl		eax, 1						}	\
				__asm {	and		eax, 7						}	\
				__asm {	mov		dl, I286_REG[ebx]			}	\
				I286CLOCK(regclk)

									// dest: MAIN_MEM[ecx] src: dl
#define	MEMORY_EA_REG8(memclk)									\
				memory_eareg8:									\
				I286CLOCK(memclk)								\
				__asm {	rol		al, 2						}	\
				__asm {	and		eax, 31						}	\
				__asm {	call	calc_ea_dst[eax*4]			}	\
				__asm {	cmp		ecx, I286_MEMWRITEMAX		}	\
				__asm {	jae		extmem_eareg8				}	\
				__asm {	mov		dl, I286_REG[ebx]			}

									// dest: al,ecx src: I286_REG[ebx]
#define EXTMEM_EA_REG8											\
				extmem_eareg8:									\
				__asm {	call	i286_memoryread				}



									// dest: I286_REG[eax*2] src: dx
#define	PREPART_EA_REG16(regclk)								\
				GET_PCBYTE										\
				__asm {	mov		ebx, eax					}	\
				__asm {	shr		ebx, 3						}	\
				__asm {	and		ebx, 7						}	\
				__asm {	cmp		al, 0c0h					}	\
				__asm {	jc		memory_eareg16				}	\
				__asm {	and		eax, 7						}	\
				__asm {	mov		dx, I286_REG[ebx*2]			}	\
				I286CLOCK(regclk)

									// dest: MAIN_MEM[ecx] src: dx
#define	MEMORY_EA_REG16(memclk)									\
				memory_eareg16:									\
				I286CLOCK(memclk)								\
				__asm {	rol		al, 2						}	\
				__asm {	and		eax, 31						}	\
				__asm {	call	calc_ea_dst[eax*4]			}	\
				__asm {	cmp		ecx, (I286_MEMWRITEMAX-1)	}	\
				__asm {	jae		extmem_eareg16				}	\
				__asm {	mov		dx, I286_REG[ebx*2]			}

									// dest: ax,ecx src: I286_REG[ebx*2]
#define EXTMEM_EA_REG16											\
				extmem_eareg16:									\
				__asm {	call	i286_memoryread_w			}


									// dest: I286_REG[ebx]  src: al
#define	PREPART_REG8_EA(regclk, memclk)							\
				GET_PCBYTE										\
				__asm {	mov		ebx, eax					}	\
				__asm {	shr		ebx, 3						}	\
				__asm {	bt		bx, 2						}	\
				__asm {	rcl		ebx, 1						}	\
				__asm {	and		ebx, 7						}	\
				__asm {	cmp		al, 0c0h					}	\
				__asm {	jnc		src_register				}	\
				I286CLOCK(memclk)								\
				__asm {	rol		al, 2						}	\
				__asm {	and		eax, 31						}	\
				__asm {	call	calc_ea_dst[eax*4]			}	\
				__asm {	call	i286_memoryread				}	\
				__asm {	jmp		reg8_ea_ready				}	\
				src_register:									\
				__asm {	bt		ax, 2						}	\
				__asm {	rcl		eax, 1						}	\
				__asm {	and		eax, 7						}	\
				__asm {	mov		al, I286_REG[eax]			}	\
				I286CLOCK(regclk)								\
				reg8_ea_ready:

									// dest: I286_REG[ebx*2]  src: ax
#define	PREPART_REG16_EA(regclk, memclk)						\
				GET_PCBYTE										\
				__asm {	mov		ebx, eax					}	\
				__asm {	shr		ebx, 3						}	\
				__asm {	and		ebx, 7						}	\
				__asm {	cmp		al, 0c0h					}	\
				__asm {	jnc		src_register				}	\
				I286CLOCK(memclk)								\
				__asm {	rol		al, 2						}	\
				__asm {	and		eax, 31						}	\
				__asm {	call	calc_ea_dst[eax*4]			}	\
				__asm {	call	i286_memoryread_w			}	\
				__asm {	jmp		reg16_ea_ready				}	\
				src_register:									\
				__asm {	and		eax, 7						}	\
				__asm {	mov		ax, I286_REG[eax*2]			}	\
				I286CLOCK(regclk)								\
				reg16_ea_ready:


									// dest: I286_REG[eax]
#define	PREPART_EA8(regclk)										\
				__asm {	cmp		al, 0c0h					}	\
				__asm {	jc		memory_eareg8				}	\
				I286CLOCK(regclk)								\
				__asm {	bt		ax, 2						}	\
				__asm { rcl		eax, 1						}	\
				__asm {	and		eax, 7						}

									// dest: MAIN_MEM[ecx]
#define	MEMORY_EA8(memclk)										\
				memory_eareg8:									\
				I286CLOCK(memclk)								\
				__asm {	rol		al, 2						}	\
				__asm {	and		eax, 31						}	\
				__asm {	call	calc_ea_dst[eax*4]			}	\
				__asm {	cmp		ecx, I286_MEMWRITEMAX		}	\
				__asm {	jae		extmem_eareg8				}

									// dest: ecx
#define EXTMEM_EA8												\
				extmem_eareg8:									\
				__asm {	call	i286_memoryread				}


									// dest: I286_REG[eax*2]
#define	PREPART_EA16(regclk)									\
				__asm {	cmp		al, 0c0h					}	\
				__asm {	jc		memory_eareg16				}	\
				I286CLOCK(regclk)								\
				__asm {	and		eax, 7						}

									// dest: MAIN_MEM[ecx]
#define	MEMORY_EA16(memclk)										\
				memory_eareg16:									\
				I286CLOCK(memclk)								\
				__asm {	rol		al, 2						}	\
				__asm {	and		eax, 31						}	\
				__asm {	call	calc_ea_dst[eax*4]			}	\
				__asm {	cmp		ecx, (I286_MEMWRITEMAX-1)	}	\
				__asm {	jae		extmem_eareg16				}

									// dest: ecx
#define EXTMEM_EA16												\
				extmem_eareg16:									\
				__asm {	call	i286_memoryread_w			}
