#include	<windows.h>
#include	"common.h"
#include	"nevent.h"
#include	"i286.h"
#include	"i286s.h"
#include	"i286rep.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"i286.mcr"
#include	"i286ea.mcr"

#define	LOAD_DS_SI												\
				__asm {	mov		edi, DS_FIX					}	\
				__asm {	movzx	ebx, I286_SI				}

// ---------------------------------------------------------------------- ins

I286EXT rep_insb(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		insb_ed
				mov		edi, ES_BASE
				movzx	ebx, I286_DI
insb_lp:		I286CLOCK(4)
				mov		cx, I286_DX
				call	i286_in
				lea		ecx, [edi + ebx]
				mov		dl, al
				call	i286_memorywrite
				STRING_DIR
				add		bx, ax
				dec		I286_CX
				jne		insb_lp
				mov		I286_DI, bx
insb_ed:		ret
		}
}

I286EXT rep_insw(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		insw_ed
				mov		edi, ES_BASE
				movzx	ebx, I286_DI
insw_lp:		I286CLOCK(4)
				mov		cx, I286_DX
				call	i286_in_w
				lea		ecx, [edi + ebx]
				mov		dx, ax
				call	i286_memorywrite_w
				STRING_DIRx2
				add		bx, ax
				dec		I286_CX
				jne		insw_lp
				mov		I286_DI, bx
insw_ed:		ret
		}
}

// ---------------------------------------------------------------------- outs

I286EXT rep_outsb(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		outsb_ed
				LOAD_DS_SI
outsb_lp:		I286CLOCK(4)
				lea		ecx, [edi + ebx]
				call	i286_memoryread
				mov		cx, I286_DX
				mov		dl, al
				call	i286_out
				STRING_DIR
				add		bx, ax
				dec		I286_CX
				jne		outsb_lp
				mov		I286_SI, bx
outsb_ed:		ret
		}
}

I286EXT rep_outsw(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		outsw_ed
				LOAD_DS_SI
outsw_lp:		I286CLOCK(4)
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		cx, I286_DX
				mov		dx, ax
				call	i286_out_w
				STRING_DIRx2
				add		bx, ax
				dec		I286_CX
				jne		outsw_lp
				mov		I286_SI, bx
outsw_ed:		ret
		}
}

// ---------------------------------------------------------------------- movs

I286EXT rep_movsb(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		movsb_ed
				push	esi
				push	ebp
				LOAD_DS_SI
				mov		esi, ES_BASE
				movzx	ebp, I286_DI
movsb_lp:		I286CLOCK(4)
				lea		ecx, [edi + ebx]
				call	i286_memoryread
				mov		edx, eax
				lea		ecx, [esi + ebp]
				call	i286_memorywrite
				STRING_DIR
				add		bx, ax
				add		bp, ax
				dec		I286_CX
				jne		movsb_lp
				mov		I286_SI, bx
				mov		I286_DI, bp
				pop		ebp
				pop		esi
movsb_ed:		ret
		}
}

I286EXT rep_movsw(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		movsw_ed
				push	esi
				push	ebp
				LOAD_DS_SI
				mov		esi, ES_BASE
				movzx	ebp, I286_DI
movsw_lp:		I286CLOCK(4)
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		edx, eax
				lea		ecx, [esi + ebp]
				call	i286_memorywrite_w
				STRING_DIRx2
				add		bx, ax
				add		bp, ax
				dec		I286_CX
				jne		movsw_lp
				mov		I286_SI, bx
				mov		I286_DI, bp
				pop		ebp
				pop		esi
movsw_ed:		ret
		}
}

// ---------------------------------------------------------------------- lods

I286EXT rep_lodsb(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		lodsb_ed
				LOAD_DS_SI
lodsb_lp:		I286CLOCK(4)
				lea		ecx, [edi + ebx]
				call	i286_memoryread
				mov		I286_AL, al
				STRING_DIR
				add		bx, ax
				dec		I286_CX
				jne		lodsb_lp
				mov		I286_SI, bx
lodsb_ed:		ret
		}
}

I286EXT rep_lodsw(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		lodsw_ed
				LOAD_DS_SI
lodsw_lp:		I286CLOCK(4)
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_AX, ax
				STRING_DIRx2
				add		bx, ax
				dec		I286_CX
				jne		lodsw_lp
				mov		I286_SI, bx
lodsw_ed:		ret
		}
}

// ---------------------------------------------------------------------- stos

I286EXT rep_stosb(void) {

		__asm {
				I286CLOCK(4)
				cmp		I286_CX, 0
				je		stosb_ed
				mov		edi, ES_BASE
				movzx	ebx, I286_DI
stosb_lp:		I286CLOCK(3)
				lea		ecx, [edi + ebx]
				mov		dl, I286_AL
				call	i286_memorywrite
				STRING_DIR
				add		bx, ax
				dec		I286_CX
				jne		stosb_lp
				mov		I286_DI, bx
stosb_ed:		ret
		}
}

I286EXT rep_stosw(void) {

		__asm {
				I286CLOCK(4)
				cmp		I286_CX, 0
				je		stosw_ed
				mov		edi, ES_BASE
				movzx	ebx, I286_DI
stosw_lp:		I286CLOCK(3)
				lea		ecx, [edi + ebx]
				mov		dx, I286_AX
				call	i286_memorywrite_w
				STRING_DIRx2
				add		bx, ax
				dec		I286_CX
				jne		stosw_lp
				mov		I286_DI, bx
stosw_ed:		ret
		}
}

// ---------------------------------------------------------------------- cmps

I286EXT repe_cmpsb(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		cmpsb_ed
				push	esi
				push	ebp
				LOAD_DS_SI
				mov		esi, ES_BASE
				movzx	ebp, I286_DI
zcmpsb_lp:		I286CLOCK(9)
				lea		ecx, [edi + ebx]
				call	i286_memoryread
				mov		dl, al
				lea		ecx, [esi + ebp]
				call	i286_memoryread
				cmp		dl, al
				FLAG_STORE_OF
				STRING_DIR
				add		bx, ax
				add		bp, ax
				dec		I286_CX
				je		zcmpsb_ed
				test	I286_FLAG, Z_FLAG
				jne		zcmpsb_lp
zcmpsb_ed:		mov		I286_SI, bx
				mov		I286_DI, bp
				pop		ebp
				pop		esi
cmpsb_ed:		ret
		}
}

I286EXT repne_cmpsb(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		cmpsb_ed
				push	esi
				push	ebp
				LOAD_DS_SI
				mov		esi, ES_BASE
				movzx	ebp, I286_DI
nzcmpsb_lp:		I286CLOCK(9)
				lea		ecx, [edi + ebx]
				call	i286_memoryread
				mov		dl, al
				lea		ecx, [esi + ebp]
				call	i286_memoryread
				cmp		dl, al
				FLAG_STORE_OF
				STRING_DIR
				add		bx, ax
				add		bp, ax
				dec		I286_CX
				je		nzcmpsb_ed
				test	I286_FLAG, Z_FLAG
				je		nzcmpsb_lp
nzcmpsb_ed:		mov		I286_SI, bx
				mov		I286_DI, bp
				pop		ebp
				pop		esi
cmpsb_ed:		ret
		}
}

I286EXT repe_cmpsw(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		cmpsw_ed
				push	esi
				push	ebp
				LOAD_DS_SI
				mov		esi, ES_BASE
				movzx	ebp, I286_DI
zcmpsw_lp:		I286CLOCK(9)
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		dx, ax
				lea		ecx, [esi + ebp]
				call	i286_memoryread_w
				cmp		dx, ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		bx, ax
				add		bp, ax
				dec		I286_CX
				je		zcmpsw_ed
				test	I286_FLAG, Z_FLAG
				jne		zcmpsw_lp
zcmpsw_ed:		mov		I286_SI, bx
				mov		I286_DI, bp
				pop		ebp
				pop		esi
cmpsw_ed:		ret
		}
}

I286EXT repne_cmpsw(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		cmpsw_ed
				push	esi
				push	ebp
				LOAD_DS_SI
				mov		esi, ES_BASE
				movzx	ebp, I286_DI
nzcmpsw_lp:		I286CLOCK(9)
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		dx, ax
				lea		ecx, [esi + ebp]
				call	i286_memoryread_w
				cmp		dx, ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		bx, ax
				add		bp, ax
				dec		I286_CX
				je		nzcmpsw_ed
				test	I286_FLAG, Z_FLAG
				je		nzcmpsw_lp
nzcmpsw_ed:		mov		I286_SI, bx
				mov		I286_DI, bp
				pop		ebp
				pop		esi
cmpsw_ed:		ret
		}
}

// ---------------------------------------------------------------------- scas

I286EXT repe_scasb(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		scasb_ed
				mov		edi, ES_BASE
				movzx	ebx, I286_DI
zscasb_lp:		I286CLOCK(8)
				lea		ecx, [edi + ebx]
				call	i286_memoryread
				cmp		I286_AL, al
				FLAG_STORE_OF
				STRING_DIR
				add		bx, ax
				dec		I286_CX
				je		zscasb_ed
				test	I286_FLAG, Z_FLAG
				jne		zscasb_lp
zscasb_ed:		mov		I286_DI, bx
scasb_ed:		ret
		}
}

I286EXT repne_scasb(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		scasb_ed
				mov		edi, ES_BASE
				movzx	ebx, I286_DI
nzscasb_lp:		I286CLOCK(8)
				lea		ecx, [edi + ebx]
				call	i286_memoryread
				cmp		I286_AL, al
				FLAG_STORE_OF
				STRING_DIR
				add		bx, ax
				dec		I286_CX
				je		nzscasb_ed
				test	I286_FLAG, Z_FLAG
				je		nzscasb_lp
nzscasb_ed:		mov		I286_DI, bx
scasb_ed:		ret
		}
}

I286EXT repe_scasw(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		scasw_ed
				mov		edi, ES_BASE
				movzx	ebx, I286_DI
zscasw_lp:		I286CLOCK(8)
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				cmp		I286_AX, ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		bx, ax
				dec		I286_CX
				je		zscasw_ed
				test	I286_FLAG, Z_FLAG
				jne		zscasw_lp
zscasw_ed:		mov		I286_DI, bx
scasw_ed:		ret
		}
}

I286EXT repne_scasw(void) {

		__asm {
				I286CLOCK(5)
				cmp		I286_CX, 0
				je		scasw_ed
				mov		edi, ES_BASE
				movzx	ebx, I286_DI
nzscasw_lp:		I286CLOCK(8)
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				cmp		I286_AX, ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		bx, ax
				dec		I286_CX
				je		nzscasw_ed
				test	I286_FLAG, Z_FLAG
				je		nzscasw_lp
nzscasw_ed:		mov		I286_DI, bx
scasw_ed:		ret
		}
}

