#include	<windows.h>
#include	<windowsx.h>
#include	<io.h>

#include	"np2.h"
#include	"iobridge.h"
#include	"dosio.h"
#include	"bios.h"
#include	"pc_core.h"
#include	"midi.h"
#include	"milstr.h"

#define		CFGLEN		(MAX_PATH + 32)

		BYTE	init_flag = 0;

		char	ini_title[]		= "NekoProjectII";

		char	cfgWINPOSX[]	= "WindposX";
		char	cfgWINPOSY[]	= "WindposY";
		char	cfgSTARTDIR[]	= "StartDir";
		char	cfgBMPDIR[]		= "bmap_Dir";
		char	cfgCLOCKBASE[]	= "clk_base";
		char	cfgCLOCKMUL[]	= "clk_mult";
		char	cfgDIPSWITCH[]	= "DIPswtch";
		char	cfgMEMSWITCH[]	= "MEMswtch";
		char	cfgOPNSOUND[]	= "OPNsound";
		char	cfgSAMPLINGRT[]	= "SampleHz";
		char	cfgDELAY[]		= "Latencys";
		char	cfgBTNRAPID[]	= "btnRAPID";
		char	cfgBTNMODE[]	= "btn_MODE";
		char	cfgNOWAIT[]		= "s_NOWAIT";
		char	cfgFRAMES[]		= "SkpFrame";
		char	cfgDISPSYNC[]	= "DispSync";
		char	cfgJOYSTICK[]	= "Joystick";
		char	cfgMOUSE[]		= "Mouse_sw";
		char	cfgDISPCLK[]	= "DspClock";
		char	cfgWINSNAP[]	= "Win_Snap";
		char	cfgMIDIMOD[]	= "MIDI_mod";
		char	cfgMIDIRST[]	= "MIDI_rst";
		char	cfgMIMPIDEF[]	= "MIMPIdef";
		char	cfgSEEKSND[]	= "Seek_Snd";
		char	cfgSEEKVOL[]	= "Seek_Vol";

		char	cfgITF[]		= "ITF_WORK";

		char	cfgHDDFILE[]	= "HDD%1dFILE";

		char	cfgLCDMODE[]	= "LCD_MODE";
		char	cfgLCDBG[]		= "BG_COLOR";
		char	cfgLCDFG[]		= "FG_COLOR";


extern	int		winx;
extern	int		winy;
		char	fileselectfolder[MAX_PATH] = "";
		char	bmpfilefolder[MAX_PATH] = "";
		char	mimpideffile[MAX_PATH] = "";

static char *makeHEX(long para, BYTE length) {

static	char	hexstrtmp[9];
		char	*p;
		char	c;

	if (length >= 8) {
		length = 8;
	}
	p = hexstrtmp + length;
	*p = '\0';
	while(length--) {
		p--;
		c = (char)(para & 0x0f);
		if (c < 10) {
			*p = c + '0';
		}
		else {
			*p = c + '7';			//	'7' = 'A' - 10;
		}
		para >>= 4;
	}
	return(p);
}


static long solveHEX(char *str) {

	long	ret;
	int		i;
	char	c;

	ret = 0;
	for (i=0; i<8; i++) {
		c = *str++;
		if ((c >= '0') && (c <= '9')) {
			c -= '0';
		}
		else if ((c >= 'A') && (c <= 'F')) {
			c -= '7';
		}
		else if ((c >= 'a') && (c <= 'f')) {
			c -= 'W';
		}
		else {
			break;
		}
		ret <<= 4;
		ret += (long)c;
	}
	return(ret);
}


static char *makeBOOL(BYTE value) {

	if (value) {
		return("true");
	}
	return("false");
}


BYTE solveBOOL(LPSTR str) {

	if ((!Aacmp(str, "TRUE")) || (!Aacmp(str, "ON")) ||
		(!Aacmp(str, "+")) || (!Aacmp(str, "1")) ||
		(!Aacmp(str, "ENABLE"))) {
		return(1);
	}
	return(0);
}


void initload(void) {

	char	initfile[MAX_PATH + 5];
	char	cfgstr[CFGLEN];
	int		i;
	char	*arg[8];
	int		args;

	init_flag = 0;

	strcpy(initfile, __argv[0]);
	cutExtName(initfile);
	strcat(initfile, ".ini");

	winx = GetPrivateProfileInt(ini_title, cfgWINPOSX,
										CW_USEDEFAULT, initfile);
	winy = GetPrivateProfileInt(ini_title, cfgWINPOSY,
										CW_USEDEFAULT, initfile);

	GetPrivateProfileString(ini_title, cfgSTARTDIR, "",
							fileselectfolder, MAX_PATH, initfile);
	GetPrivateProfileString(ini_title, cfgBMPDIR, "",
							bmpfilefolder, MAX_PATH, initfile);
	GetPrivateProfileString(ini_title, cfgMIMPIDEF, "",
							mimpideffile, MAX_PATH, initfile);

	for (i=0; i<2; i++) {
		wsprintf(cfgstr, cfgHDDFILE, i+1);
		GetPrivateProfileString(ini_title, cfgstr, "",
							hd_name[i], MAX_PATH, initfile);
	}

	np2cfg.baseclock = (DWORD)GetPrivateProfileInt(
						ini_title, cfgCLOCKBASE, PCBASECLOCK25, initfile);
	np2cfg.multiple = (DWORD)GetPrivateProfileInt(
								ini_title, cfgCLOCKMUL, 2, initfile);

	GetPrivateProfileString(ini_title, cfgDIPSWITCH, "",
										cfgstr, CFGLEN, initfile);
	args = milstr_getarg(cfgstr, arg, 3);
	if (args == 3) {
		for (i=0; i<args; i++) {
			np2cfg.dipsw[i] = (BYTE)solveHEX(arg[i]);
		}
	}
	GetPrivateProfileString(ini_title, cfgMEMSWITCH, "",
										cfgstr, CFGLEN, initfile);
	args = milstr_getarg(cfgstr, arg, 8);
	if (args == 8) {
		for (i=0; i<args; i++) {
			np2cfg.memsw[i] = (BYTE)solveHEX(arg[i]);
		}
	}

	GetPrivateProfileString(ini_title, cfgOPNSOUND, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.SOUND_SW = solveBOOL(cfgstr);

	np2cfg.samplingrate = (WORD)GetPrivateProfileInt(
								ini_title, cfgSAMPLINGRT, 22050, initfile);
	np2cfg.delayms = (WORD)GetPrivateProfileInt(
								ini_title, cfgDELAY, 1000, initfile);

	GetPrivateProfileString(ini_title, cfgBTNRAPID, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.BTN_RAPID = solveBOOL(cfgstr);
	GetPrivateProfileString(ini_title, cfgBTNMODE, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.BTN_MODE = solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgNOWAIT, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.NOWAIT = solveBOOL(cfgstr);
	np2cfg.DRAW_SKIP = (BYTE)GetPrivateProfileInt(ini_title, cfgFRAMES,
															1, initfile);
	GetPrivateProfileString(ini_title, cfgDISPSYNC, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.DISPSYNC = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgSEEKSND, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.MOTOR = solveBOOL(cfgstr);
	if ((np2cfg.MOTORVOL = (BYTE)GetPrivateProfileInt(ini_title, cfgSEEKVOL,
												80, initfile)) > 100) {
		np2cfg.MOTORVOL = 100;
	}

	GetPrivateProfileString(ini_title, cfgJOYSTICK, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.JOYSTICK = (BYTE)solveBOOL(cfgstr);
	GetPrivateProfileString(ini_title, cfgMOUSE, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.MOUSE_SW = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgWINSNAP, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.WINSNAP = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgDISPCLK, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.DISPCLK = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgMIDIMOD, "",
										cfgstr, CFGLEN, initfile);
	np2cfg.MIDIMODULE = MIDI_module2num(cfgstr);
	GetPrivateProfileString(ini_title, cfgMIDIRST, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.MIDIRESET = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, "I286SAVE", "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.I286SAVE = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgITF, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.ITF_WORK = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgLCDMODE, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.LCD_MODE = (BYTE)solveBOOL(cfgstr);
	GetPrivateProfileString(ini_title, cfgLCDBG, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.BG_COLOR = solveHEX(cfgstr) & 0xffffff;
	GetPrivateProfileString(ini_title, cfgLCDFG, "ffffff",
										cfgstr, CFGLEN, initfile);
	np2cfg.FG_COLOR = solveHEX(cfgstr) & 0xffffff;
}


void initsave(void) {

	char	initfile[MAX_PATH + 5];
	char	cfgstr[CFGLEN];
	int		i;

	if (!init_flag) {
		return;
	}

	strcpy(initfile, __argv[0]);
	cutExtName(initfile);
	strcat(initfile, ".ini");

	wsprintf(cfgstr, "%d", winx);
	WritePrivateProfileString(ini_title, cfgWINPOSX, cfgstr, initfile);
	wsprintf(cfgstr, "%d", winy);
	WritePrivateProfileString(ini_title, cfgWINPOSY, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgSTARTDIR,
										fileselectfolder, initfile);
	WritePrivateProfileString(ini_title, cfgBMPDIR,
										bmpfilefolder, initfile);
	WritePrivateProfileString(ini_title, cfgMIMPIDEF,
										mimpideffile, initfile);

	for (i=0; i<2; i++) {
		wsprintf(cfgstr, cfgHDDFILE, i+1);
		WritePrivateProfileString(ini_title, cfgstr,
										hd_name[i], initfile);
	}

	wsprintf(cfgstr, "%u", np2cfg.baseclock);
	WritePrivateProfileString(ini_title, cfgCLOCKBASE, cfgstr, initfile);
	wsprintf(cfgstr, "%u", np2cfg.multiple);
	WritePrivateProfileString(ini_title, cfgCLOCKMUL, cfgstr, initfile);

	for (i=0; i<3; i++) {
		wsprintf(&cfgstr[i*3], "%02x ", np2cfg.dipsw[i]);
	}
	cfgstr[3*3-1] = '\0';
	WritePrivateProfileString(ini_title, cfgDIPSWITCH, cfgstr, initfile);
	for (i=0; i<8; i++) {
		wsprintf(&cfgstr[i*3], "%02x ", np2cfg.memsw[i]);
	}
	cfgstr[8*3-1] = '\0';
	WritePrivateProfileString(ini_title, cfgMEMSWITCH, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgOPNSOUND,
									makeBOOL(np2cfg.SOUND_SW), initfile);

	wsprintf(cfgstr, "%u", np2cfg.samplingrate);
	WritePrivateProfileString(ini_title, cfgSAMPLINGRT, cfgstr, initfile);
	wsprintf(cfgstr, "%u", np2cfg.delayms);
	WritePrivateProfileString(ini_title, cfgDELAY, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgBTNRAPID,
									makeBOOL(np2cfg.BTN_RAPID), initfile);
	WritePrivateProfileString(ini_title, cfgBTNMODE,
									makeBOOL(np2cfg.BTN_MODE), initfile);

	WritePrivateProfileString(ini_title, cfgNOWAIT,
									makeBOOL(np2cfg.NOWAIT), initfile);
	wsprintf(cfgstr, "%u", np2cfg.DRAW_SKIP);
	WritePrivateProfileString(ini_title, cfgFRAMES, cfgstr, initfile);
	WritePrivateProfileString(ini_title, cfgDISPSYNC,
									makeBOOL(np2cfg.DISPSYNC & 1), initfile);

	WritePrivateProfileString(ini_title, cfgJOYSTICK,
									makeBOOL(np2cfg.JOYSTICK & 1), initfile);
	WritePrivateProfileString(ini_title, cfgMOUSE,
									makeBOOL(np2cfg.MOUSE_SW & 1), initfile);

	WritePrivateProfileString(ini_title, cfgSEEKSND,
									makeBOOL(np2cfg.MOTOR), initfile);
	wsprintf(cfgstr, "%u", np2cfg.MOTORVOL);
	WritePrivateProfileString(ini_title, cfgSEEKVOL, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgDISPCLK,
									makeBOOL(np2cfg.DISPCLK & 1), initfile);

	WritePrivateProfileString(ini_title, cfgMIDIMOD,
							MIDI_num2module(np2cfg.MIDIMODULE), initfile);
	WritePrivateProfileString(ini_title, cfgMIDIRST,
									makeBOOL(np2cfg.MIDIRESET & 1), initfile);

	WritePrivateProfileString(ini_title, cfgWINSNAP,
									makeBOOL(np2cfg.WINSNAP & 1), initfile);
}

