#include	<windows.h>
#include	<windowsx.h>

#include	"resource.h"
#include	"np2.h"
#include	"pc_core.h"
#include	"dosio.h"
#include	"ini.h"
#include	"menu.h"
#include	"bios.h"
#include	"ddraws.h"
#include	"dsound3.h"
#include	"fddfile.h"
#include	"s98.h"

extern	HWND	hWndMain;


#define	MFCHECK(a) ((a)?MF_CHECKED:MF_UNCHECKED)


typedef struct {
	int		index;
	char	*str;
} FILTER_T;

static	FILTER_T	fdd_filter = {
					3,	"D88 image files (*.D88;*.D98)\0"					\
										"*.d88;*.88d;*.d98;*.98d\0"			\
						"Normal disk images (*.XDF;*.HDM;*.DUP;*.2HD)\0"	\
										"*.xdf;*.hdm;*.dup;*.2hd;*.tfd\0"	\
						"All supported Files\0"								\
										"*.d88;*.88d;*.d98;*.98d;"			\
										"*.xdf;*.hdm;*.dup;*.2hd;*.tfd\0"	\
						"All files (*.*)\0*.*\0\0"};

#if 1
static	FILTER_T	hdd_filter = {
					3,	"T98 harddisk image files (*.THD)\0"				\
										"*.thd\0"							\
						"ANEX86 harddisk image files (*.HDI)\0"				\
										"*.hdi\0"							\
						"All supported Files\0"								\
										"*.thd;*.hdi\0\0"};
#else
static	FILTER_T	hdd_filter = {
					3,	"Virtual98 harddisk image files (*.HDD)\0"			\
										"*.hdd\0"							\
						"T98 harddisk image files (*.THD)\0"				\
										"*.thd\0"							\
						"All supported Files\0"								\
										"*.thd;*.hdd\0\0"};
#endif


LPSTR savefileselect(LPSTR filter, LPSTR defname, LPSTR ext, LPSTR title) {

		OPENFILENAME	ofn;
		BOOL			r;
static	char			pathname[MAX_PATH+16];
static	char			filename[MAX_PATH];
		int				i;
		char			*p;

	ZeroMemory(&ofn, sizeof(OPENFILENAME));

	strcpy(pathname, bmpfilefolder);
	cutFileName(pathname);
	p = pathname + strlen(pathname);
	for (i=0; i<10000; i++) {
		wsprintf(filename, defname, i);
		strcpy(p, filename);
		if (file_attr(pathname) == -1) {
			break;
		}
	}
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter = filter;
	ofn.lpstrFile = pathname;
	ofn.lpstrFileTitle = filename;
	ofn.nFilterIndex = 1;
	ofn.nMaxFile = MAX_PATH;
	ofn.nMaxFileTitle = sizeof(filename);
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = ext;
	ofn.lpstrTitle = title;

	DSound_Stop();
	mx_topwinui();
	r = GetSaveFileName(&ofn);
	mx_clearwinui();
	DSound_Play();
	if (!r) {
		return(NULL);
	}
	INIT_RENEWAL
		strcpy(bmpfilefolder, pathname);
	return(pathname);
}

LPSTR filenameselect(LPSTR fname, char *title, char *search, char *ext) {

		OPENFILENAME	ofn;
		BOOL			r;
static	char			pathname[MAX_PATH];
static	char			filename[MAX_PATH] = "";

	if ((fname == NULL) || (fname[0] == '\0')) {
		fname = "";
	}
	strcpy(pathname, fname);
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter = search;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = pathname;
	ofn.lpstrFileTitle = filename;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST;
	ofn.lpstrDefExt = ext;
	ofn.lpstrTitle = title;

	r = GetOpenFileName(&ofn);
	if (!r) {
		return(NULL);
	}
	return(pathname);
}

// -------------------------------------------------------------------------

static LPSTR fileselect(LPSTR defname, FILTER_T *filter) {

		OPENFILENAME	ofn;
		BOOL			r;
static	char			pathname[MAX_PATH];
static	char			filename[MAX_PATH] = "";

	if ((defname == NULL) || (defname[0] == '\0')) {
		defname = fileselectfolder;
	}
	strcpy(pathname, defname);
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter = filter->str;
	ofn.nFilterIndex = filter->index;
	ofn.lpstrFile = pathname;
	ofn.lpstrFileTitle = filename;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST;
	ofn.lpstrDefExt = "d88";
	ofn.lpstrTitle = "ҰނJ";

	DSound_Stop();
	mx_topwinui();
	r = GetOpenFileName(&ofn);
	mx_clearwinui();
	DSound_Play();
	if (!r) {
		return(NULL);
	}

	INIT_RENEWAL
		strcpy(fileselectfolder, pathname);
	return(pathname);
}


void changehdd(BYTE drv) {

	LPSTR	p;

	if (drv < 2) {
		p = fileselect(hd_name[drv], &hdd_filter);
		if (p) {
			mx_strncpy(hd_name[drv], p, MAX_PATH);
		}
	}
}

void changefdd(BYTE drv) {

	char	*p;

	if (drv >= 4) {
		return;
	}
	p = fileselect(fdd_diskname(drv), &fdd_filter);
	if (p) {
		fdd_set(drv, p);
	}
	makecaption(1, 0);
}

void makecaption(BYTE flg, long khz) {

static	char	title[1024] = "";
static	char	clock[64] = "";

	char	work[1024+64+2];

	if (flg & 1) {
		strcpy(title, szProgName);
		if (fdd_diskready(0)) {
			strcat(title, "  FDD1:");
			strcat(title, getFileName(fdd_diskname(0)));
		}
		if (fdd_diskready(1)) {
			strcat(title, "  FDD2:");
			strcat(title, getFileName(fdd_diskname(1)));
		}
	}
	if (flg & 2) {
		if (khz) {
			wsprintf(clock, " - %2u.%03uMHz", (khz / 1000), (khz % 1000));
		}
		else {
			clock[0] = '\0';
		}
	}
	strcpy(work, title);
	strcat(work, clock);
	SetWindowText(hWndMain, work);
}


void disable_windowmenu(void) {

	HMENU	hmenu = GetMenu(hWndMain);

	EnableMenuItem(hmenu, IDM_WINDOW, MF_GRAYED);
	EnableMenuItem(hmenu, IDM_FULLSCREEN, MF_GRAYED);
}

#if 0
void xmenu_setsound(BYTE value) {

	xmilcfg.SOUND_SW = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_FMBOARD, MFCHECK(value));
}
#endif

void xmenu_setkey(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	if (value >= 3) {
		value = 0;
	}
	np2cfg.KEY_MODE = value;
	CheckMenuItem(hmenu, IDM_KEY, MFCHECK(value == 0));
	CheckMenuItem(hmenu, IDM_JOY1, MFCHECK(value == 1));
	CheckMenuItem(hmenu, IDM_JOY2, MFCHECK(value == 2));
}

void xmenu_setbtnrapid(BYTE value) {

	np2cfg.BTN_RAPID = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_RAPID, MFCHECK(np2cfg.BTN_RAPID));
}

void xmenu_setbtnmode(BYTE value) {

	np2cfg.BTN_MODE = value & 1;
	CheckMenuItem(GetMenu(hWndMain), IDM_JOYX, MFCHECK(np2cfg.BTN_MODE));
}

void xmenu_setwaitflg(BYTE value) {

	np2cfg.NOWAIT = value & 1;
	CheckMenuItem(GetMenu(hWndMain), IDM_NOWAIT, MFCHECK(np2cfg.NOWAIT));
}

void xmenu_setflame(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.DRAW_SKIP = value;
	CheckMenuItem(hmenu, IDM_60FPS, MFCHECK(value == 1));
	CheckMenuItem(hmenu, IDM_30FPS, MFCHECK(value == 2));
	CheckMenuItem(hmenu, IDM_20FPS, MFCHECK(value == 3));
	CheckMenuItem(hmenu, IDM_15FPS, MFCHECK(value == 4));
}

void xmenu_setjoystick(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.JOYSTICK &= 0x80;
	np2cfg.JOYSTICK |= (value & 0x7f);

	if (value & 2) {
		EnableMenuItem(hmenu, IDM_JOYSTICK, MF_GRAYED);
	}
	else {
		CheckMenuItem(hmenu, IDM_JOYSTICK, MFCHECK(value & 1));
	}
}

void xmenu_setdispclk(BYTE value) {

	value &= 1;
	np2cfg.DISPCLK = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_DISPCLOCK, MFCHECK(value));
	makecaption(2, 0);
	if (value) {
		workclock_reset();
	}
}

void xmenu_setdispmode(BYTE value) {

	value &= 1;
	np2cfg.DISPSYNC = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_DISPSYNC, MFCHECK(value));
}

void xmenu_setmouse(BYTE value) {

	value &= 1;
	np2cfg.MOUSE_SW = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_MOUSE, MFCHECK(value));
}

void xmenu_setmotorflg(BYTE value) {

	np2cfg.MOTOR = value & 1;
	CheckMenuItem(GetMenu(hWndMain), IDM_SEEKSND, MFCHECK(np2cfg.MOTOR));
}

void xmenu_setwinsnap(BYTE value) {

	value &= 1;
	np2cfg.WINSNAP = value;
	CheckMenuItem(GetSystemMenu(hWndMain, FALSE),
									IDM_SNAPENABLE, MFCHECK(value));
}

void xmenu_seti286save(BYTE value) {

	if (!value) {
		EnableMenuItem(GetMenu(hWndMain), IDM_I286SAVE, MF_GRAYED);
	}
}

void xmenu_setmimpidef(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.MIMPIDEF = value;
	if (!(value & 0x80)) {
		EnableMenuItem(hmenu, IDM_MIMPIFILE, MF_ENABLED);
		CheckMenuItem(hmenu, IDM_MIMPIFILE, MFCHECK(value & 1));
	}
	else {
		EnableMenuItem(hmenu, IDM_MIMPIFILE, MF_GRAYED);
		CheckMenuItem(hmenu, IDM_MIMPIFILE, MF_UNCHECKED);
	}
}

void xmenu_s98save(void)
{
	HMENU	hmenu = GetMenu(hWndMain);

	CheckMenuItem(hmenu, IDM_S98SAVE, MFCHECK(S98_logging()));
}
