#include	<windows.h>
#include	"common.h"
#include	"i286.h"
#include	"iobridge.h"
#include	"pic.h"
#include	"nevent.h"

	PIC_TABLE	pic[2];

static	PIC_TABLE	defaultpic[2] = {
							{0, {0, 0, 0, 0, 0, 0, 0, 0},
								{7, 6, 5, 4, 3, 2, 1, 0},
								{0, 0x08, 0x80, 0},
								~(PIC_KEYBOARD | PIC_SLAVE),
								0, 0, 0},
							{0, {0, 0, 0, 0, 0, 0, 0, 0},
								{7, 6, 5, 4, 3, 2, 1, 0},
								{0, 0x10, 0x07, 0},
								0xff,
								0, 0, 0}};


static void pic_rolpry(PIC_TABLE *picp) {

	// ͂́[@ˁc
	*(DWORD *)(&picp->pry[0]) =
			(*(DWORD *)(&picp->pry[0]) + 0x01010101) & 0x07070707;
	*(DWORD *)(&picp->pry[4]) =
			(*(DWORD *)(&picp->pry[4]) + 0x01010101) & 0x07070707;
}


static void pic_downbylevel(PIC_TABLE *picp, BYTE level) {

	int		i;

	for (i=0; i<8; i++) {
		if (picp->pry[i] < picp->pry[level]) {
			(picp->pry[i])++;
		}
	}
	picp->pry[level] = 0;
}


// eoi
static void pic_forceeoibylevel(PIC_TABLE *picp, BYTE level) {

	int		i;

	if (picp->isr & (1 << level)) {
		picp->isr &= ~(1 << level);
		(picp->levels)--;
		for (i=0; (i<picp->levels) && (picp->level[i] != level); i++);
		for (; i<picp->levels; i++) {
			picp->level[i] = picp->level[i+1];
		}
	}
}


// wirqɊ݂o邩`FbN
static void pic_irq1(int item) {

	int		i;
	BYTE	bit;
	BYTE	pry = 0xff;
	BYTE	irq;
	BYTE	targetbit = 0;
	PIC_TABLE	*picp = &pic[item];

	if (!(picp->irr & (~picp->imr))) {
		return;
	}
	if (picp->levels) {
		pry = picp->pry[picp->level[picp->levels - 1]];
	}
	for (bit=1, i=0; bit; bit<<=1, i++) {
		if ((picp->irr & bit) && (!((picp->imr | picp->isr) & bit))) {
			if ((pry == 0xff) || (picp->pry[i] > pry)) {
				pry = picp->pry[i];
				irq = (BYTE)i;
				targetbit = bit;
			}
		}
	}
	if (targetbit) {
		picp->isr |= targetbit;
		picp->irr ^= targetbit;
		picp->level[picp->levels++] = irq;

		if ((item != 0) || (!(pic[0].icw[2] & targetbit))) {
			i286_interrupt((picp->icw[1] & 0xf8) | irq);
		}
	}
}


void pic_init(void) {

	CopyMemory(pic, defaultpic, sizeof(pic));
}


void pic_irq(void) {

	if (I286_IFLAG) {
		pic_irq1(0);
		if ((pic[0].levels) && 
			(pic[0].icw[2] & (1 << pic[0].level[pic[0].levels - 1]))) {
			pic_irq1(1);
		}
	}
}



// ȈՃ[h(SYSTEM TIMER)
void picmask(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		pic[0].irr &= ~(pic[0].imr & PIC_SYSTEMTIMER);
	}
}

void pic_setirq(BYTE irq) {

	BYTE	bit = 1 << (irq & 7);

	irq &= 0x0f;
	if (irq < 8) {
		if (!(pic[0].imr & bit)) {
			pic[0].irr |= bit;
		}
		else {
			if (bit & PIC_SYSTEMTIMER) {
				pic[0].irr |= bit;
				nevent_set(NEVENT_PICMASK, 32, picmask, NEVENT_ABSOLUTE);
			}
		}
	}
	else {
		if ((!(pic[0].imr & 0x80)) && (!(pic[1].imr & bit))) {
			pic[0].irr |= 0x80;
			pic[1].irr |= bit;
		}
	}
	pic_irq();
}


I286_OUT pic_w(WORD port, BYTE value) {

	PIC_TABLE	*picp = &pic[(port >> 3) & 1];
	BYTE		level;

	if (!(port & 2)) {						// port 00:
		switch(value & 0x18) {
			case 0x00:						// eoi
				if (value & 0x40) {
					level = value & 7;
				}
				else {
					if (picp->levels == 0) {
						break;
					}
					level = picp->level[picp->levels - 1];
				}
				if (value & 0x80) {
					if (!(value & 0x40)) {
						pic_rolpry(picp);
					}
					else {
						pic_downbylevel(picp, level);
					}
				}
				if (value & 0x20) {
					pic_forceeoibylevel(picp, level);
				}
				break;
			case 0x08:						// ocw3
				picp->ocw3 = value;
				break;
		}
	}
	else {									// port 02:
		picp->imr = value;
	}
}


I286_INB pic_r(WORD port) {

	PIC_TABLE	*picp = &pic[(port >> 3) & 1];

	if (!(port & 2)) {						// port 00:
		switch(picp->ocw3 & 0x03) {
			case 0x02:						// read irr
				return(picp->irr);
			case 0x03:						// read isr
				return(picp->isr);
			default:
				return(0xff);
		}
	}
	return(picp->imr);						// port 02:
}

